unit Unit1;

{
  permutaties en rangorde conversie
  elementen 1,2,3,4,5,6,7,8,9,10,11,12
  rangordes 0..479001599
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, shellApi;

type
  TForm1 = class(TForm)
    elnrtext: TStaticText;
    elPlusBtn: TSpeedButton;
    elMinBtn: TSpeedButton;
    Label1: TLabel;
    rangEdit: TEdit;
    label6: TLabel;
    permEdit: TEdit;
    Label3: TLabel;
    Label2: TLabel;
    permBtn: TSpeedButton;
    rangBtn: TSpeedButton;
    Label4: TLabel;
    Label5: TLabel;
    Image1: TImage;
    msglabel: TLabel;
    pclearBtn: TSpeedButton;
    rangclearBtn: TSpeedButton;
    rangPlusBtn: TSpeedButton;
    rtangMinBtn: TSpeedButton;
    Timer1: TTimer;
    maxRangBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure rangclearBtnClick(Sender: TObject);
    procedure pclearBtnClick(Sender: TObject);
    procedure permBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure rangPlusBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure rangPlusBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1Click(Sender: TObject);
    procedure rangEditKeyPress(Sender: TObject; var Key: Char);
    procedure permEditKeyPress(Sender: TObject; var Key: Char);
    procedure elPlusBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure rangBtnClick(Sender: TObject);
    procedure maxRangBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var faclist : array[0..12] of dword;//0! ... 12!
    rang : dword = 0;
    maxelement : byte = 12;
    perm0 : array[1..12] of byte; //permutatie nr 0
    element : array[1..12] of byte;
    timercode : byte;

//-- helpers

procedure makepermutationlist;
var i : byte;
begin
 faclist[0] := 1;
 faclist[1] := 1;
 for i := 2 to 12 do faclist[i] := faclist[i-1]*i;
end;

procedure showpermutatie;
var s : string;
    i : byte;
begin
 s := '';
 for i := 1 to maxelement do
  begin
   s := s + inttostr(element[i]);
   if i < maxelement then s := s + ', ';
  end;
 form1.permEdit.text := s;
end;

//-- rang --> permutatie

procedure maakpermutatie;
//rang nummer naar permutatie
var rest,pNr   : dword;
    column,count,i,j : byte;
begin
 for i := 1 to maxelement do perm0[i] := i;//maak permutatie 0
 pNr := rang;
 count := maxelement;     //aantal elementen waaruit wordt gekozen
 for i := 1 to maxelement do
  begin
   dec(count);
   rest := pNr mod faclist[count];
   column := pNr div faclist[count]+1;
   element[i] := perm0[column];
   for j := column to count do perm0[j] := perm0[j+1];//shift left
   pNr := rest;
  end;
end;

function checkrang : boolean;
begin
 with form1.rangEdit do
  begin
   if length(text) = 0 then text := '0';
   rang := strtoint(text);
   result := rang < faclist[maxelement];
   if result then form1.msglabel.caption := ''
    else form1.msglabel.caption := 'rangorde te hoog'
  end;
end;

procedure TForm1.permBtnClick(Sender: TObject);
// permutation button click
begin
 if checkRang then
  begin
   maakpermutatie;
   showpermutatie;
  end;
end;

procedure TForm1.maxRangBtnClick(Sender: TObject);
//hoogste rang
begin
 rang := faclist[maxelement]-1;
 rangEdit.Text := inttostr(rang);
 maakpermutatie;
 showpermutatie;
end;

//--- permutatie --> rang

procedure maakrang;
//permutatie naar rang conversie
var i,j,elcount : byte;
    column : dword;
    perm1 : array[1..12] of byte;
begin
 elcount := maxelement;
 rang := 0;
 for i := 1 to elCount do perm1[i] := i;
 for i := 1 to elCount do
  begin
   column := 1;
   while element[i] <> perm1[column] do inc(column);
   dec(elCount);
   rang := rang + (column-1)*faclist[elCount];
   for j := column to elCount do perm1[j] := perm1[j+1];
  end;
end;

function checkpermutatie : boolean;
//check proper elements , make array element[ ]
//set element count
//return true if OK
type Tscan = (scDigit,scSpacer);
var Ncount : array[1..12] of byte;
    s,snr : string;
    i,elcount,n,sLength : byte;
    scanmode : Tscan;
    errorcode : byte;
begin
 s := form1.permEdit.Text+ ' ';
 SLength := length(s);
 for i := 1 to 12 do element[i] := 0;
 elCount := 0;
 i := 0;
 scanmode := scSpacer;
 errorcode := 0;
 while (errorcode = 0) and (i < SLength) do
  begin
   inc(i);
    case s[i] of
     '0'..'9' : case scanmode of
                 scDigit   : begin
                              snr := snr + s[i];
                              if length(snr) > 2 then errorcode := 1;
                             end;
                 scSpacer  : begin
                             snr := s[i];
                             scanmode := scDigit;
                            end;
                end;//case
     ' ',','  : case scanmode of
                 scDigit : begin
                            inc(elCount);
                            if elCount > 12 then errorcode := 2
                             else
                              begin
                               n := strtoint(snr);
                               if (n = 0) or (n > 12) then errorcode := 3
                                else element[elCount] := strtoint(snr);
                              end;
                            scanMode := scSpacer;
                           end;
                 scSpacer : ;
                end;
   end; //case
  end;//while
 if errorcode = 0 then
  begin
   for i := 1 to 12 do Ncount[i] := 0;
   for i := 1 to elCount do inc(Ncount[element[i]]);
   i := 1;
   while (i <= elCount) and (errorcode=0) do
    if Ncount[i] = 0 then errorcode := 3
     else
      if Ncount[i] > 1 then errorcode := 4
       else inc(i);
  end;
 result := false;
 with form1.msglabel do
  case errorcode of
   0 : begin
        result := true;
        maxelement := elCount;
        form1.elnrtext.caption := inttostr(elCount);
        caption := '';
       end;
   1 : caption := 'onbekend element';
   2 : caption := 'teveel elementen';
   3 : caption := 'ontbrekend element';
   4 : caption := 'herhaald element';
 end;
end;

procedure TForm1.rangBtnClick(Sender: TObject);
//maak rang uit permutatie
begin
 if checkpermutatie then
  begin
   maakrang;
   rangEdit.text := inttostr(rang);
  end;
end; 

// -- instellingen

procedure rangChange;
//verander de rang
//dir 1 : UP; 2 : DOWN
var change : boolean;
begin
 change := false;
 form1.msglabel.Caption := '';
 case timercode of
  1 : if rang < faclist[maxelement]-1 then
        begin
         inc(rang);
         change := true;
        end
         else form1.msglabel.Caption := 'maximale rang bereikt';
  2 : if rang > 0 then
        begin
         dec(rang);
         change := true;
        end;
 end;
 if change then
  begin
   form1.rangEdit.Text := inttostr(rang);
   maakpermutatie;
   showpermutatie;
  end;
end;

procedure elNrChange;
//verander aantal elementen
begin
 form1.msglabel.Caption := '';
 case timercode of
  11 : if maxelement < 12 then inc(maxelement);
  12 : if maxelement > 1 then dec(maxelement);
 end;
 if rang >= faclist[maxelement] then
    begin
     rang := 0;
     form1.rangEdit.Text := '0';
    end;
 with form1 do
  begin
   ElNrText.caption := inttostr(maxelement);
   permEdit.Text := '';
  end;
end;

procedure TForm1.rangPlusBtnMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 timercode := TSpeedbutton(sender).Tag;
 rangChange;
 timer1.Enabled := true;
end;

procedure TForm1.elPlusBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 timercode := TSpeedButton(sender).Tag;
 ElNrChange;
 timer1.Enabled := true;
end;

procedure TForm1.rangPlusBtnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 timercode := 0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 case timercode of
  0     : timer1.Enabled := false;
  1,2   : RangChange;
  11,12 : ElNrChange;
 end;//case
end;

//-- clear

procedure TForm1.rangclearBtnClick(Sender: TObject);
begin
 rangEdit.Text := '0';
 rang := 0;
end;

procedure TForm1.pclearBtnClick(Sender: TObject);
var i : byte;
begin
 permEdit.Text := '';
 for i := 1 to 12 do element[i] := 0;
 msglabel.caption := '';
end;

//-- keyboard filters

procedure TForm1.rangEditKeyPress(Sender: TObject; var Key: Char);
//filter for rang edit
begin
 if not (key in ['0'..'9',#8]) then key := #0;
end;

procedure TForm1.permEditKeyPress(Sender: TObject; var Key: Char);
//filter for permutation edit
begin
 if not (key in['0'..'9',',',' ',#8]) then key := #0;
end;

// -- misc

procedure TForm1.FormCreate(Sender: TObject);
begin
 makepermutationlist;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
 ShellExecute(0,'open','http://www.davdata.nl/', nil, nil, SW_SHOWNORMAL);
end;

end.
